#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:16777216")
#include <string>
#include <vector>
#include <map>
#include <list>
#include <iterator>
#include <set>
#include <queue>
#include <iostream>
#include <sstream>
#include <stack>
#include <deque>
#include <cmath>
#include <memory.h>
#include <cstdlib>
#include <cstdio>
#include <cctype>
#include <algorithm>
#include <utility>
#include <time.h>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i < (b); ++i)
#define RFOR(i, b, a) for(int i = (b) - 1; i >= (a); --i)
#define REP(i, N) FOR(i, 0, N)
#define RREP(i, N) RFOR(i, N, 0)
#define FILL(A,value) memset(A,value,sizeof(A))

#define ALL(V) V.begin(), V.end()
#define SZ(V) (int)V.size()
#define PB push_back
#define MP make_pair
#define Pi 3.14159265358979

typedef long long Int;
typedef unsigned long long UINT;
typedef vector <int> VI;
typedef pair <int, int> PII;

const int INF = 1000000000;
const int MAXN = 100000;
const int MAX2 = 7000;
const int BASE = 1000000000;

int C[MAXN*2];
int n, m;
VI A, B;

void Read()
{
	cin >> n >> m;
	FOR (i,0,n)
	{
		int x;
		scanf("%d", &x);
		A.PB(x);
	}
	FOR (i,0,m)
	{
		int x;
		scanf("%d", &x);
		B.PB(x);
	}
}

void Sort(vector<int>& A)
{
	FILL(C, 0);
	FOR (i,0,SZ(A))
		++ C[A[i]];
	A.clear();
	FOR (i,0,MAXN*2)
		FOR (j,0,C[i])
			A.PB(i);
}

int Solve()
{
	Sort(A);
	Sort(B);

	int res = -1;
	int pos = 0;
	FOR (i,2,MAXN*3)
	{
		int l = i/2;
		int r = i-1;
		bool ok = 1;
			if (A[0] < l || A[SZ(A)-1] > r)
				ok = 0;
		while (pos < SZ(B) && B[pos] < l)
			 ++ pos;
		if (pos < SZ(B) && B[pos] <= r)
				ok = 0;
		if (ok)
		{
			res = i;
			break;
		}
	}
	printf("%d\n", res);
	return res;
}


int main()
{
    freopen("metro.dat", "r", stdin);
    freopen("metro.sol", "w", stdout);

    Read();
    Solve();


    return 0;
}
